var URL = window.URL || window.webkitURL;
var gumStream;                      //stream from getUserMedia()
var rec;                            //Recorder.js object
var input;                          //MediaStreamAudioSourceNode we'll be recording
var record_nodeid;
var record_ansid;

// shim for AudioContext when it's not avb. 
var AudioContext = window.AudioContext || window.webkitAudioContext;
var audioContext //audio context to help us record
var wavinvalid = 0;

$(document).ready(function() {

    bs_input_file();

    $('.stopButton').prop('disabled',true);
    $('.pauseButton').prop('disabled',true);

    $('#upfile').on('change', function(e) {
        var files = $('#upfile')[0].files;
        var ftype = files[0].type;

        var blob = files[0]; // See step 1 above
        var fileReader = new FileReader();

        fileReader.onloadend = function(e) {
            var arr = (new Uint8Array(e.target.result)).subarray(0, 12);
            var header = "";
            for(var i = 0; i < arr.length; i++) {
                header += arr[i].toString(16);
            }
            // check wave file valid header
            var firsth = header.substr(0,8);
            var lasth  = header.substr(header.length-8);
            if(firsth!='52494646' || lasth!='57415645') {
               wavinvalid=1;
               alertify.alert('Warning','Please upload a valid wav file');
            } else {
               wavinvalid=0;
            }
 
        };

        fileReader.readAsArrayBuffer(blob);
  
        return false;
    });

    $('body').on('click', 'button.recordButton', function(event) { event.preventDefault(); startRecording(this); });
    $('body').on('click', 'button.stopButton',  function(event) { event.preventDefault(); stopRecording(this);  });
    $('body').on('click', 'button.pauseButton',  function(event) { event.preventDefault(); pauseRecording(this); });
    $('body').on('click', 'button.uploadButton',  function(event) { 
         event.preventDefault(); 
         partes = $(this).attr('id').substr(13).split('-');
         nodeid = partes[0];
         answerid = partes[1];
         var filename = pad(nodeid,8)+'_'+pad(answerid,8)+'.wav';

         if(nodeid=='number') {
             filename=answerid+'.wav';
         }
         console.log(filename);
         $('#uploadfname').val(filename);
         $('#uploadansid').val(answerid);
         $('#UploadModal').modal();
    });

    $('#uploadwaveform').submit(function(e) {

        ansid = $('#uploadansid').val();
        //console.log('submit');
        e.preventDefault();

        if(wavinvalid==1) { return; }

        var formData = new FormData(this);
        var savedSrc = $('#sound_'+ansid).attr('src');
        $('#sound_'+ansid).attr('src','');
        $.ajax({
           type: "POST",
           url: window.location.pathname,
           data: formData,
           success: function(data)
           {
               $('#uploadwaveform').trigger('reset');
               $('#UploadModal').modal('hide');
               $('#sound_'+ansid).attr('src',savedSrc);
           },
           cache: false,
           contentType: false,
           processData: false
         });

    });

});

function startRecording(el) {

    var butid = $(el).attr('id').substr(13);
console.log('button id '+butid);
    record_nodeid = butid.split('-')[0];
console.log('record nodeid '+record_nodeid);
    record_ansid  = butid.split('-')[1];
console.log('record ans id '+record_ansid);

    var constraints = { audio: true, video:false }

    $('.recordButton').prop('disabled',true);
    $('#stopButton_'+butid).prop('disabled',false);
    $('#pauseButton_'+butid).prop('disabled',false);

    /*
        We're using the standard promise based getUserMedia() 
        https://developer.mozilla.org/en-US/docs/Web/API/MediaDevices/getUserMedia
    */

    navigator.mediaDevices.getUserMedia(constraints).then(function(stream) {

        console.log("getUserMedia() success, stream created, initializing Recorder.js ...");

        /*
            create an audio context after getUserMedia is called
            sampleRate might change after getUserMedia is called, like it does on macOS when recording through AirPods
            the sampleRate defaults to the one set in your OS for your playback device

        */
        audioContext = new AudioContext();

        // update the format 
        // document.getElementById("formats").innerHTML="Format: 1 channel pcm @ "+audioContext.sampleRate/1000+"kHz"

        /*  assign to gumStream for later use  */
        gumStream = stream;
        
        /* use the stream */
        input = audioContext.createMediaStreamSource(stream);

        /* 
            Create the Recorder object and configure to record mono sound (1 channel)
            Recording 2 channels  will double the file size
        */
        rec = new Recorder(input,{numChannels:1})

        //start the recording process
        rec.record()

        console.log("Recording started");

    }).catch(function(err) {
          //enable the record button if getUserMedia() fails
        $('.recordButton').prop('disabled',false);
        $('#stopButton_'+butid).prop('disabled',true);
        $('#pauseButton_'+butid).prop('disabled',true);
    });
}

function pauseRecording(el) {

    var butid = $(el).attr('id').substr(12);

    console.log("pauseButton clicked rec.recording=",rec.recording );

    if (rec.recording){
        //pause
        rec.stop();
        $('#pauseButton_'+butid).html("Resume");
    }else{
        //resume
        rec.record()
        $('#pauseButton_'+butid).html("Pause");

    }
}

function stopRecording(el) {

    var butid = $(el).attr('id').substr(11);

    //disable the stop button, enable the record too allow for new recordings
    $('.recordButton').prop('disabled',false);
    $('#stopButton_'+butid).prop('disabled',true);
    $('#pauseButton_'+butid).prop('disabled',true);
    //reset button just in case the recording is stopped while paused
    $('#pauseButton_'+butid).html("Pause");
    
    //tell the recorder to stop the recording
    rec.stop();

    //stop microphone access
    gumStream.getAudioTracks()[0].stop();

    //create the wav blob and pass it on to createDownloadLink
    rec.exportWAV(createDownloadLink);

}

function createDownloadLink(blob) {
    
    var url = URL.createObjectURL(blob);

    //name of .wav file to use during upload and download (without extendion)
    var nodeid = record_nodeid;
    if(nodeid===null) { nodeid='0' };

    var answerid = record_ansid;
    if(answerid===null) { answerid='0'; }

    console.log('node id '+nodeid);
    console.log('answer id '+answerid);

    var filename = pad(nodeid,8)+'_'+pad(answerid,8)+'.wav';

    if(nodeid=='number') {
        filename=answerid+'.wav';
    }

    console.log('filename '+filename);

    //add controls to the <audio> element
    $('#sound_'+answerid).attr('src',url);

  //  $('#uploadButton').prop('disabled',false);
//    $('#uploadButton')[0].addEventListener("click", function(event){
          var xhr=new XMLHttpRequest();
          xhr.onload=function(e) {
              if(this.readyState === 4) {
                  $('body').css('opacity','1');
                  console.log('end upload');
              }
          };
          var fd=new FormData();
          fd.append("filename",blob, filename);
          xhr.open("POST",window.location.href,true);
          xhr.send(fd);
          $('body').css('opacity','0.5');
//    })

}

function pad(n, width, z) {
  z = z || '0';
  n = n + '';
  return n.length >= width ? n : new Array(width - n.length + 1).join(z) + n;
}

function bs_input_file() {
    $(".input-file").before(
        function() {
            if ( ! $(this).prev().hasClass('input-ghost') ) {
                var element = $("<input id='upfile' type='file' class='input-ghost' style='visibility:hidden; height:0'>");
                element.attr("name",$(this).attr("name"));
                element.change(function(){
                    element.next(element).find('input').val((element.val()).split('\\').pop());
                });
                $(this).find("button.btn-choose").click(function(){
                    element.click();
                });
                $(this).find("button.btn-reset").click(function(){
                    element.val(null);
                    $(this).parents(".input-file").find('input').val('');
                });
                $(this).find('input').css("cursor","pointer");
                $(this).find('input').mousedown(function() {
                    $(this).parents('.input-file').prev().click();
                    return false;
                });
                return element;
            }
        }
    );
}


