<?php

function send_request($myscheme,$token) {

    global $cookiestring;

    $uri          = $myscheme['request']['uri'];
    $method       = isset($myscheme['request']['method'])?$myscheme['request']['method']:'POST';
    $port         = isset($myscheme['request']['port'])?$myscheme['request']['port']:'443';
    $field_key    = isset($myscheme['request']['field_key'])?$myscheme['request']['field_key']:'';
    $field_result = isset($myscheme['request']['field_result'])?$myscheme['request']['field_result']:'';
    $payload      = isset($myscheme['request']['payload'])?$myscheme['request']['payload']:'';
    $format       = isset($myscheme['request']['format'])?$myscheme['request']['format']:'form';
    $send_cookies = isset($myscheme['request']['send_cookies'])?$myscheme['request']['send_cookies']:'0';
    $type         = isset($myscheme['request']['type'])?$myscheme['request']['type']:'';
    $headers      = isset($myscheme['request']['headers'])?$myscheme['request']['headers']:array();
    $auth_header  = isset($myscheme['request']['auth_header'])?$myscheme['request']['auth_header']:'none';
    $username     = isset($myscheme['request']['username'])?$myscheme['request']['username']:'';
    $password     = isset($myscheme['request']['password'])?$myscheme['request']['password']:'';

    if($method=='GET') {
        $obj = Httpful\Request::get($uri);
    } else if ($method=='POST') {
        $obj = Httpful\Request::post($uri);
    } else {
        // default get
        $obj = Httpful\Request::get($uri);
    }

    if($auth_header=='basic') {
        if($username<>'') {
            $obj->authenticateWith($username, $password);
        }
    } else if($auth_header=='ntlm') {
        if($username<>'') {
            $obj->authenticateWithNTLM($username, $password);
        }
    } else if($auth_header=='digest') {
        if($username<>'') {
            $obj->authenticateWithDigest($username, $password);
        }
    }

    if($format=='form') {
        $obj->sendsForm();
    } else if($format=='json') {
        $payload = urldecode($payload);
        parse_str($payload,$arr);
        $payload = json_encode($arr);
        $obj->sendsJSON();
    } else {
        $obj->sendsForm();
    }

    if($send_cookies==1) {
        $obj->addHeader('Cookie',$cookiestring);
    }

    foreach($headers as $header) {
        list($header,$value) = preg_split("/\|/",$header);
        $value = preg_replace('/{token}/',$token,$value);
        $obj->addHeader($header,$value);
    }

    if($payload <> '') {
        $obj->body($payload);
    }

    $result = $obj->send();

    $http_code = $result->{'code'};

    $response = objectToArray($result->body);


    if($field_key<>'') {
        $return = get_result_key_recursive($response,$field_key,array());
    } else {
        $return = $response;
    }

    if($type=='search') {

        $results = array();
        foreach($return as $resp) {
            if(!is_array($resp)) { continue; }
            $field_result_final = preg_replace_callback('/{([^}][a-zA-Z0-9_]*)}/', function($matches) use ($resp) { return $resp[substr($matches[0],1,-1)]; }, $field_result);
            $results[] = array("name"=>$field_result_final,"data"=>json_encode($resp));
        }
        echo json_encode($results);
    } else {
        if($http_code=='200') {
            echo json_encode($return);
        } else {
            echo '{ "response":"error", "http_status_code":"'.$http_code.'" }';
        }
    }

    return $return;

}

function get_token($myscheme) {

    global $cookiestring;

    $uri     = $myscheme['authenticate']['uri'];
    $method  = isset($myscheme['authenticate']['method'])?$myscheme['authenticate']['method']:'POST';
    $port    = isset($myscheme['authenticate']['port'])?$myscheme['authenticate']['port']:'443';
    $payload = isset($myscheme['authenticate']['payload'])?$myscheme['authenticate']['payload']:'username==admin&password=admin';
    $cookies = isset($myscheme['authenticate']['save_cookies'])?$myscheme['authenticate']['save_cookies']:'0';

    $response_type = isset($myscheme['authenticate']['response']['type'])?$myscheme['authenticate']['response']['type']:'json';
    $response_token_key = isset($myscheme['authenticate']['response']['token_key'])?$myscheme['authenticate']['response']['token_key']:'json';
    $response_token_transform = isset($myscheme['authenticate']['response']['token_transform'])?$myscheme['authenticate']['response']['token_transform']:'';

    if($method=='POST') {
        $obj = Httpful\Request::POST($uri);
    } else if($method=='GET') {
        $obj = Httpful\Request::GET($uri);
    }

    $obj->sendsForm();
    $obj->body($payload);
    $rsp = $obj->send();

    if($cookies==1) {
        $cookiestring = cookie_jar($rsp->raw_headers);
    }

    $token='';
    if($response_type == 'plain') {
        $token = $rsp->body;
    } else if($response_type == 'json') {
        if(isset($rsp->body)) {
            if(isset($rsp->body->{$response_token_key})) {
                $token = $rsp->body->{$response_token_key};
            }
        }
    }

    if($response_token_transform<>'') {
        ob_start();
        eval("echo $response_token_transform;");
        $token = ob_get_contents();
        ob_end_clean();
    }
    return $token;
}

